param(
[string]$UserName,
[string]$ServerName,
[AllowEmptyString()]
[string]$ComputerName,
[AllowEmptyString()]
[string]$IPAddress)

$logfile = "C:\Temp\FileAuditScriptLogoffAndDisable.log"

"Security breach from User: $UserName Computer: $ComputerName " | out-file -filepath $logfile -append
get-date | out-file -filepath $logfile -append

if($ComputerName)
{
    ((quser.exe /server:"$ComputerName" | Where-Object { $_ -match "$UserName" }) -split  +) | out-file -filepath $logfile -append
    $sessionId = ((quser.exe /server:"$ComputerName" | Where-Object { $_ -match "$UserName" }) -split  +)[3]
    $sessionId | out-file -filepath $logfile -append
    logoff $sessionId /server:"$ComputerName" | out-file -filepath $logfile -append

    if(Test-Connection -cn $IPAddress -Count 1 -Quiet) {
    "PC responds to ping before shutdown" | out-file -filepath $logfile -append
    } else {
    "Warning: PC doesnt respond to ping before shutdown, you may not see if shutdown was successfull" | out-file -filepath $logfile -append
    }

    Stop-Computer -cn $IPAddress -Force -AsJob
    Get-Job | Wait-Job -Timeout 30 | out-file -filepath $logfile -append 
    Get-Job | Remove-Job -Force

    if(Test-Connection -cn $IPAddress -Count 1 -Quiet) {
    "Problem: PC still responds to ping after shutdown!" | out-file -filepath $logfile -append
    }
}
else
{
    ((quser.exe /server:"$ServerName" | Where-Object { $_ -match "$UserName" }) -split  +) | out-file -filepath $logfile -append
    $sessionId = ((quser.exe /server:"$ServerName" | Where-Object { $_ -match "$UserName" }) -split  +)[3]
    $sessionId | out-file -filepath $logfile -append
    logoff $sessionId /server:"$ServerName" | out-file -filepath $logfile -append
} 

"All done."| out-file -filepath $logfile -append
